<?php
namespace Intrackt\ArtPlacer;

/*
 * load the source for any required classes or files
 */
require_once( INTRACKT_ARTPLACER_PLUGIN_DIR . 'class.Intrackt-ArtPlacer-PageLog.php' );
require_once( INTRACKT_ARTPLACER_PLUGIN_DIR . 'class.Intrackt-ArtPlacer-Actions.php' );
require_once(\ABSPATH.'/wp-admin/includes/template.php');

/*
 * The PageMain class defines and processes the ArtPlacer main page
 */
class PageMain {

    /*
     * Have we instantiated the class-- this is a singleton and does not produce children
     */
	private static $initiated = false;
    
    /*
     * Init class
     */
	public static function init() {
        
        //PageLog::updateTestLog("PageMain::init executed");
        
		if ( ! self::$initiated ) {
    		self::$initiated = true;

		}
        
	}
    
    /*
     * display some html in the section
     */
    public static function page01Section01Text() {

    ?>
    <h3 style='font-size: 1.15em;'>Configuration Settings</h3>
    <?php
    
    }

    /*
     * validate input values
     */
    public static function optionsValidate($input) {

        //PageLog::updateTestLog("optionsValidate");
        /*
         * Get the options
         */
        $options = \get_option('intrackt_artplacer');
        
        /*
         * Validate all the options from this form (leaving others untouched)
         * If validation failed, don't change exising value.
         */
        $option=\trim($input['intrackt_artplacer_option1']);
        if (\preg_match('/^[01]{1,1}$/i', $option)) {
            $options['option1'] =$option;
        }
        
        /*
         * update options
         */
        \update_option('intrackt_artplacer',$options);

    }

    /*
     * Handle auto assign of artplacer to new products
     */
    public static function options_option1() {
    
        /*
         * create the input widget
         */
        $options = \get_option('intrackt_artplacer');
        echo "<select id='intrackt_artplacer_option1' name='intrackt_artplacer_options[intrackt_artplacer_option1]' style='width: 560px;'>".
                "<option value=1 ".(($options['option1']==1)?'selected ':'').">Yes</option>".
                "<option value=0 ".(($options['option1']==0)?'selected ':'').">No</option>".
            "</select>";

    }

    /*
     * Define Options
     */
    public static function optionsDefine() {        
      
        /*
         * Get the options
         */
        $options = \get_option('intrackt_artplacer');
        
        /*
         * get options and set this one to the default if not set
         */
        if (!array_key_exists('option1',$options)) {
            $options['option1']='0';
        }
 
        \update_option('intrackt_artplacer',$options);

        /*
         * Define the options form
         */
        \register_setting( 'intrackt_artplacer_options', 'intrackt_artplacer_options', array( 'Intrackt\ArtPlacer\PageMain', 'optionsValidate' ) );
        
        \add_settings_section('intrackt_artplacer_p01s01', '', array( 'Intrackt\ArtPlacer\PageMain', 'page01Section01Text' ), 'intrackt_artplacer_options_page');
        
        \add_settings_field('intrackt_artplacer_option1', 'Option one meaning', array( 'Intrackt\ArtPlacer\PageMain', 'options_option1' ), 'intrackt_artplacer_p01', 'intrackt_artplacer_p01s01');

    }

    /*
     * Process page
     */
    public static function processPage() {
        
        //PageLog::updateTestLog("PageMain::processPage: start");
        
        /*
         * do the cron job
         */
        if ($_POST['artplaceraction']=="action1") {
            Actions::action1();
        } elseif ($_POST['artplaceraction']=="action2") {
            Actions::action2();
        }

        $_POST['artplaceraction']="";
    }

    /*
     * Display the page
     */
    public static function displayPage() {
        
        ?>

        <div class="wrap">
        <div style='display: none;'><h2 style="display: none">       <h2>
        </div><h1>Intrackt ArtPlacer</h1>

            
        <!--
         Options form
        -->
        <script>
            
            /*
             * control all vendor options form client-side logic
             */
            document.addEventListener("DOMContentLoaded", processArtPlacerOptionsForm);
            function processArtPlacerOptionsForm() {
                
                /*
                 * handle unload with changes made
                 */
                {
                    /*
                     * the form
                     */
                    myForm=document.getElementById('intrackt_options_form');
                    
                    /*
                     * intercept submits so that they do not count
                     */
                    myForm.addEventListener('submit',settingsSubmitted);
                    
                    /*
                     * intercept all changes
                     */
                    formElements=myForm.elements;
                    for (i=0;i<formElements.length;i++)
                        formElements[i].addEventListener('change',handleChanges);
                    
                    /*
                     * the unload handler itself
                     */
                    window.addEventListener("beforeunload",handleUnload);
                }
                
            }
            
            /*
             * remove class (too gassy) and left justify setting labels
             */
            $formTables=document.getElementsByClassName('form-table');
            for (i=$formTables.length-1;i>=0;i--) {
                $formTables[i].style.textAlign='left';
                $formTables[i].className='';
            }

            /*
             * intercept submit event
             */
            var formSubmitted=false;
            function settingsSubmitted(e) {
                formSubmitted=true;
            }
            
            /*
             * intercept all changes
             */
            var formChanges=false;
            function handleChanges(e) {
                formChanges=true;
            }
            
            /*
             * Handle unload of page
             */
            function handleUnload(e) {
                
                /*
                 * if form being submitted, skip unload message
                 */
                if (formSubmitted) return undefined;
                
                /*
                 * if no changes
                 */
                if (!formChanges) return undefined;
                
                /*
                 * we need to warn the user
                 */
                returnMsg="You have made changes to your settings.  Are you sure you want to abandon those changes?";
                (e||window.event).returnValue=returnMsg;
                return returnMsg;
            }
            
        </script>


        <div id="ok_to_interact">
            
        </div>
        
        <!--
        Div to show while doing work
        -->
        <div id="doing_work" style="display:none;">
        <h2>Working ...</h2>
            What's happening.  Please wait ...
        </div>
        
        <script>
            
            /*
             * attached to action submit button
             */
            function showAssigning() {
                $doWork=document.getElementById('ok_to_interact');
                $doingWork=document.getElementById('doing_work');
                $doWork.style.display='none';
                $doingWork.style.display='inline';
                return true;
                }

        </script>

        </div>
        <?php
    }    
    
 }

/*
 * Process any forms on this page
 */
if (isset($_POST['artplaceraction'])) {
    PageMain::processPage();
}
